---
title: Create LDAP Gateway
description: The POST {{apiPath}}/v1/environments/{{envID}}/gateways operation adds a new LDAP gateway resource to the specified environment.
component: pingone-api
page_id: pingone-api:platform:gateway-management/gateways/create-ldap-gateway
canonical_url: https://developer.pingidentity.com/pingone-api/platform/gateway-management/gateways/create-ldap-gateway.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create LDAP Gateway

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/gateways
```

The `POST {{apiPath}}/v1/environments/{{envID}}/gateways` operation adds a new LDAP gateway resource to the specified environment.

|   |                                                 |
| - | ----------------------------------------------- |
|   | Do not use a load balancer as the LDAP gateway. |

### Prerequisites

* Refer to [Gateway Management](../../gateway-management.html) for important overview information.

* [Create a population](../../populations/create-population.html) to get a `{{popID}}` for the body. For more information, refer to [Populations](../../populations.html)

> **Collapse: Request Model**
>
> For property descriptions, refer to [Gateway base data model](../gateways.html#gateway-base-data-model).
>
> | Property                        | Type      | Required? |
> | ------------------------------- | --------- | --------- |
> | `credentials`                   | Object\[] | Optional  |
> | `description`                   | String    | Optional  |
> | `_embedded.instances`           | Object\[] | Optional  |
> | `enabled`                       | Boolean   | Required  |
> | `name`                          | String    | Required  |
> | `supportedVersions`             | Object    | Optional  |
> | `supportedVersions.version`     | String    | Optional  |
> | `supportedVersions.image`       | String    | Optional  |
> | `supportedVersions.recommended` | Boolean   | Optional  |
> | `supportedVersions.latest`      | Boolean   | Optional  |
> | `type`                          | String    | Required  |
>
> For LDAP gateway property descriptions, refer to [Gateway LDAP data model](../gateways.html#gateway-ldap-data-model).
>
> | Property                                          | Type      | Required? |
> | ------------------------------------------------- | --------- | --------- |
> | `bindDN`                                          | String    | Required  |
> | `bindPassword`                                    | String    | Required  |
> | `connectionSecurity`                              | String    | Optional  |
> | `kerberos`                                        | Object    | Optional  |
> | `kerberos.serviceAccountPassword`                 | String    | Optional  |
> | `kerberos.serviceAccountUserPrincipalName`        | String    | Required  |
> | `kerberos.minutesToRetainPreviousCredentials`     | Integer   | Optional  |
> | `serversHostAndPort`                              | String\[] | Required  |
> | `userTypes`                                       | Object\[] | Required  |
> | `userTypes.allowPasswordChanges`                  | Boolean   | Optional  |
> | `userTypes.updateUserOnSuccessfulAuthentication`  | Boolean   | Optional  |
> | `userTypes.id`                                    | UUID      | Required  |
> | `userTypes.name`                                  | String    | Required  |
> | `userTypes.newUserLookup`                         | Object    | Optional  |
> | `userTypes.newUserLookup.attributeMappings`       | Object\[] | Required  |
> | `userTypes.newUserLookup.attributeMappings.name`  | String    | Required  |
> | `userTypes.newUserLookup.attributeMappings.value` | Object    | Required  |
> | `userTypes.newUserLookup.ldapFilterPattern`       | String    | Optional  |
> | `userTypes.newUserLookup.population`              | String    | Optional  |
> | `userTypes.newUserLookup.population.id`           | UUID      | Optional  |
> | `userTypes.orderedCorrelationAttributes`          | Object\[] | Optional  |
> | `userTypes.passwordAuthority`                     | String    | Required  |
> | `userTypes.searchBaseDn`                          | String    | Optional  |
> | `validateTlsCertificates`                         | Boolean   | Optional  |
> | `vendor`                                          | String    | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "vendor": "PingDirectory",
    "serversHostAndPort": [
        "host1:389",
        "host.domain.com:389",
        "10.10.10.10:333",
        "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ],
    "bindDN": "cn=svc-account",
    "bindPassword": "{{bindPassword}}",
    "searchBaseDN": "o=example",
    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
    "userTypes": [
        {
            "id": "{{userTypeID}}",
            "name": "myType",
            "passwordAuthority": "LDAP",
            "searchBaseDn": "dc=example,dc=com",
            "orderedCorrelationAttributes": [
                "externalid",
                "uid",
                "username"
            ],
            "allowPasswordChanges": false,
            "updateUserOnSuccessfulAuthentication": false,
            "newUserLookup": {
                "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
                "population": {
                    "id": "{{popID}}"
                },
                "attributeMappings": [
                    {
                        "name": "username",
                        "value": "${ldapAttributes.uid}"
                    }
                ]
            }
        }
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/gateways' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "vendor": "PingDirectory",
    "serversHostAndPort": [
        "host1:389",
        "host.domain.com:389",
        "10.10.10.10:333",
        "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ],
    "bindDN": "cn=svc-account",
    "bindPassword": "{{bindPassword}}",
    "searchBaseDN": "o=example",
    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
    "userTypes": [
        {
            "id": "{{userTypeID}}",
            "name": "myType",
            "passwordAuthority": "LDAP",
            "searchBaseDn": "dc=example,dc=com",
            "orderedCorrelationAttributes": [
                "externalid",
                "uid",
                "username"
            ],
            "allowPasswordChanges": false,
            "updateUserOnSuccessfulAuthentication": false,
            "newUserLookup": {
                "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
                "population": {
                    "id": "{{popID}}"
                },
                "attributeMappings": [
                    {
                        "name": "username",
                        "value": "${ldapAttributes.uid}"
                    }
                ]
            }
        }
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/gateways")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""name"": ""LDAP-Gateway-NewTest""," + "\n" +
@"    ""description"": ""My gateway""," + "\n" +
@"    ""type"": ""LDAP""," + "\n" +
@"    ""enabled"": true," + "\n" +
@"    ""vendor"": ""PingDirectory""," + "\n" +
@"    ""serversHostAndPort"": [" + "\n" +
@"        ""host1:389""," + "\n" +
@"        ""host.domain.com:389""," + "\n" +
@"        ""10.10.10.10:333""," + "\n" +
@"        ""2001:0db8:85a3:0000:0000:8a2e:0370:7334:389""" + "\n" +
@"    ]," + "\n" +
@"    ""bindDN"": ""cn=svc-account""," + "\n" +
@"    ""bindPassword"": ""{{bindPassword}}""," + "\n" +
@"    ""searchBaseDN"": ""o=example""," + "\n" +
@"    ""userCorrelationFilterPattern"": ""(|(uid=$username$)(mail=$username$))""," + "\n" +
@"    ""userTypes"": [" + "\n" +
@"        {" + "\n" +
@"            ""id"": ""{{userTypeID}}""," + "\n" +
@"            ""name"": ""myType""," + "\n" +
@"            ""passwordAuthority"": ""LDAP""," + "\n" +
@"            ""searchBaseDn"": ""dc=example,dc=com""," + "\n" +
@"            ""orderedCorrelationAttributes"": [" + "\n" +
@"                ""externalid""," + "\n" +
@"                ""uid""," + "\n" +
@"                ""username""" + "\n" +
@"            ]," + "\n" +
@"            ""allowPasswordChanges"": false," + "\n" +
@"            ""updateUserOnSuccessfulAuthentication"": false," + "\n" +
@"            ""newUserLookup"": {" + "\n" +
@"                ""ldapFilterPattern"": ""(|(uid=${identifier})(mail=${identifier}))""," + "\n" +
@"                ""population"": {" + "\n" +
@"                    ""id"": ""{{popID}}""" + "\n" +
@"                }," + "\n" +
@"                ""attributeMappings"": [" + "\n" +
@"                    {" + "\n" +
@"                        ""name"": ""username""," + "\n" +
@"                        ""value"": ""${ldapAttributes.uid}""" + "\n" +
@"                    }" + "\n" +
@"                ]" + "\n" +
@"            }" + "\n" +
@"        }" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/gateways"
  method := "POST"

  payload := strings.NewReader(`{
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "vendor": "PingDirectory",
    "serversHostAndPort": [
        "host1:389",
        "host.domain.com:389",
        "10.10.10.10:333",
        "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ],
    "bindDN": "cn=svc-account",
    "bindPassword": "{{bindPassword}}",
    "searchBaseDN": "o=example",
    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
    "userTypes": [
        {
            "id": "{{userTypeID}}",
            "name": "myType",
            "passwordAuthority": "LDAP",
            "searchBaseDn": "dc=example,dc=com",
            "orderedCorrelationAttributes": [
                "externalid",
                "uid",
                "username"
            ],
            "allowPasswordChanges": false,
            "updateUserOnSuccessfulAuthentication": false,
            "newUserLookup": {
                "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
                "population": {
                    "id": "{{popID}}"
                },
                "attributeMappings": [
                    {
                        "name": "username",
                        "value": "${ldapAttributes.uid}"
                    }
                ]
            }
        }
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/gateways HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "vendor": "PingDirectory",
    "serversHostAndPort": [
        "host1:389",
        "host.domain.com:389",
        "10.10.10.10:333",
        "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ],
    "bindDN": "cn=svc-account",
    "bindPassword": "{{bindPassword}}",
    "searchBaseDN": "o=example",
    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
    "userTypes": [
        {
            "id": "{{userTypeID}}",
            "name": "myType",
            "passwordAuthority": "LDAP",
            "searchBaseDn": "dc=example,dc=com",
            "orderedCorrelationAttributes": [
                "externalid",
                "uid",
                "username"
            ],
            "allowPasswordChanges": false,
            "updateUserOnSuccessfulAuthentication": false,
            "newUserLookup": {
                "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
                "population": {
                    "id": "{{popID}}"
                },
                "attributeMappings": [
                    {
                        "name": "username",
                        "value": "${ldapAttributes.uid}"
                    }
                ]
            }
        }
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"name\": \"LDAP-Gateway-NewTest\",\n    \"description\": \"My gateway\",\n    \"type\": \"LDAP\",\n    \"enabled\": true,\n    \"vendor\": \"PingDirectory\",\n    \"serversHostAndPort\": [\n        \"host1:389\",\n        \"host.domain.com:389\",\n        \"10.10.10.10:333\",\n        \"2001:0db8:85a3:0000:0000:8a2e:0370:7334:389\"\n    ],\n    \"bindDN\": \"cn=svc-account\",\n    \"bindPassword\": \"{{bindPassword}}\",\n    \"searchBaseDN\": \"o=example\",\n    \"userCorrelationFilterPattern\": \"(|(uid=$username$)(mail=$username$))\",\n    \"userTypes\": [\n        {\n            \"id\": \"{{userTypeID}}\",\n            \"name\": \"myType\",\n            \"passwordAuthority\": \"LDAP\",\n            \"searchBaseDn\": \"dc=example,dc=com\",\n            \"orderedCorrelationAttributes\": [\n                \"externalid\",\n                \"uid\",\n                \"username\"\n            ],\n            \"allowPasswordChanges\": false,\n            \"updateUserOnSuccessfulAuthentication\": false,\n            \"newUserLookup\": {\n                \"ldapFilterPattern\": \"(|(uid=${identifier})(mail=${identifier}))\",\n                \"population\": {\n                    \"id\": \"{{popID}}\"\n                },\n                \"attributeMappings\": [\n                    {\n                        \"name\": \"username\",\n                        \"value\": \"${ldapAttributes.uid}\"\n                    }\n                ]\n            }\n        }\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/gateways")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/gateways",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "vendor": "PingDirectory",
    "serversHostAndPort": [
      "host1:389",
      "host.domain.com:389",
      "10.10.10.10:333",
      "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ],
    "bindDN": "cn=svc-account",
    "bindPassword": "{{bindPassword}}",
    "searchBaseDN": "o=example",
    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
    "userTypes": [
      {
        "id": "{{userTypeID}}",
        "name": "myType",
        "passwordAuthority": "LDAP",
        "searchBaseDn": "dc=example,dc=com",
        "orderedCorrelationAttributes": [
          "externalid",
          "uid",
          "username"
        ],
        "allowPasswordChanges": false,
        "updateUserOnSuccessfulAuthentication": false,
        "newUserLookup": {
          "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
          "population": {
            "id": "{{popID}}"
          },
          "attributeMappings": [
            {
              "name": "username",
              "value": "${ldapAttributes.uid}"
            }
          ]
        }
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/gateways',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "vendor": "PingDirectory",
    "serversHostAndPort": [
      "host1:389",
      "host.domain.com:389",
      "10.10.10.10:333",
      "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ],
    "bindDN": "cn=svc-account",
    "bindPassword": "{{bindPassword}}",
    "searchBaseDN": "o=example",
    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
    "userTypes": [
      {
        "id": "{{userTypeID}}",
        "name": "myType",
        "passwordAuthority": "LDAP",
        "searchBaseDn": "dc=example,dc=com",
        "orderedCorrelationAttributes": [
          "externalid",
          "uid",
          "username"
        ],
        "allowPasswordChanges": false,
        "updateUserOnSuccessfulAuthentication": false,
        "newUserLookup": {
          "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
          "population": {
            "id": "{{popID}}"
          },
          "attributeMappings": [
            {
              "name": "username",
              "value": "${ldapAttributes.uid}"
            }
          ]
        }
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/gateways"

payload = json.dumps({
  "name": "LDAP-Gateway-NewTest",
  "description": "My gateway",
  "type": "LDAP",
  "enabled": True,
  "vendor": "PingDirectory",
  "serversHostAndPort": [
    "host1:389",
    "host.domain.com:389",
    "10.10.10.10:333",
    "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
  ],
  "bindDN": "cn=svc-account",
  "bindPassword": "{{bindPassword}}",
  "searchBaseDN": "o=example",
  "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",
  "userTypes": [
    {
      "id": "{{userTypeID}}",
      "name": "myType",
      "passwordAuthority": "LDAP",
      "searchBaseDn": "dc=example,dc=com",
      "orderedCorrelationAttributes": [
        "externalid",
        "uid",
        "username"
      ],
      "allowPasswordChanges": False,
      "updateUserOnSuccessfulAuthentication": False,
      "newUserLookup": {
        "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
        "population": {
          "id": "{{popID}}"
        },
        "attributeMappings": [
          {
            "name": "username",
            "value": "${ldapAttributes.uid}"
          }
        ]
      }
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/gateways');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "name": "LDAP-Gateway-NewTest",\n    "description": "My gateway",\n    "type": "LDAP",\n    "enabled": true,\n    "vendor": "PingDirectory",\n    "serversHostAndPort": [\n        "host1:389",\n        "host.domain.com:389",\n        "10.10.10.10:333",\n        "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"\n    ],\n    "bindDN": "cn=svc-account",\n    "bindPassword": "{{bindPassword}}",\n    "searchBaseDN": "o=example",\n    "userCorrelationFilterPattern": "(|(uid=$username$)(mail=$username$))",\n    "userTypes": [\n        {\n            "id": "{{userTypeID}}",\n            "name": "myType",\n            "passwordAuthority": "LDAP",\n            "searchBaseDn": "dc=example,dc=com",\n            "orderedCorrelationAttributes": [\n                "externalid",\n                "uid",\n                "username"\n            ],\n            "allowPasswordChanges": false,\n            "updateUserOnSuccessfulAuthentication": false,\n            "newUserLookup": {\n                "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",\n                "population": {\n                    "id": "{{popID}}"\n                },\n                "attributeMappings": [\n                    {\n                        "name": "username",\n                        "value": "${ldapAttributes.uid}"\n                    }\n                ]\n            }\n        }\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/gateways")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "LDAP-Gateway-NewTest",
  "description": "My gateway",
  "type": "LDAP",
  "enabled": true,
  "vendor": "PingDirectory",
  "serversHostAndPort": [
    "host1:389",
    "host.domain.com:389",
    "10.10.10.10:333",
    "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
  ],
  "bindDN": "cn=svc-account",
  "bindPassword": "{{bindPassword}}",
  "searchBaseDN": "o=example",
  "userCorrelationFilterPattern": "(|(uid=\$username\$)(mail=\$username\$))",
  "userTypes": [
    {
      "id": "{{userTypeID}}",
      "name": "myType",
      "passwordAuthority": "LDAP",
      "searchBaseDn": "dc=example,dc=com",
      "orderedCorrelationAttributes": [
        "externalid",
        "uid",
        "username"
      ],
      "allowPasswordChanges": false,
      "updateUserOnSuccessfulAuthentication": false,
      "newUserLookup": {
        "ldapFilterPattern": "(|(uid=\${identifier})(mail=\${identifier}))",
        "population": {
          "id": "{{popID}}"
        },
        "attributeMappings": [
          {
            "name": "username",
            "value": "\${ldapAttributes.uid}"
          }
        ]
      }
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"name\": \"LDAP-Gateway-NewTest\",\n    \"description\": \"My gateway\",\n    \"type\": \"LDAP\",\n    \"enabled\": true,\n    \"vendor\": \"PingDirectory\",\n    \"serversHostAndPort\": [\n        \"host1:389\",\n        \"host.domain.com:389\",\n        \"10.10.10.10:333\",\n        \"2001:0db8:85a3:0000:0000:8a2e:0370:7334:389\"\n    ],\n    \"bindDN\": \"cn=svc-account\",\n    \"bindPassword\": \"{{bindPassword}}\",\n    \"searchBaseDN\": \"o=example\",\n    \"userCorrelationFilterPattern\": \"(|(uid=$username$)(mail=$username$))\",\n    \"userTypes\": [\n        {\n            \"id\": \"{{userTypeID}}\",\n            \"name\": \"myType\",\n            \"passwordAuthority\": \"LDAP\",\n            \"searchBaseDn\": \"dc=example,dc=com\",\n            \"orderedCorrelationAttributes\": [\n                \"externalid\",\n                \"uid\",\n                \"username\"\n            ],\n            \"allowPasswordChanges\": false,\n            \"updateUserOnSuccessfulAuthentication\": false,\n            \"newUserLookup\": {\n                \"ldapFilterPattern\": \"(|(uid=${identifier})(mail=${identifier}))\",\n                \"population\": {\n                    \"id\": \"{{popID}}\"\n                },\n                \"attributeMappings\": [\n                    {\n                        \"name\": \"username\",\n                        \"value\": \"${ldapAttributes.uid}\"\n                    }\n                ]\n            }\n        }\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/gateways")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/gateways/aa9a7286-2923-4581-b401-c57a7c05de32"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "instances": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/gateways/aa9a7286-2923-4581-b401-c57a7c05de32/instances"
        },
        "credentials": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/gateways/aa9a7286-2923-4581-b401-c57a7c05de32/credentials"
        }
    },
    "id": "aa9a7286-2923-4581-b401-c57a7c05de32",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "name": "LDAP-Gateway-NewTest",
    "description": "My gateway",
    "type": "LDAP",
    "enabled": true,
    "supportedVersions": [
        {
            "version": "3.0.4",
            "image": "pingidentity/pingone-ldap-gateway:3.0.4",
            "recommended": true,
            "latest": true
        },
        {
            "version": "3.0.1",
            "image": "pingidentity/pingone-ldap-gateway:3.0.1",
            "supportEndsOn": "2024-12-31T00:00:00.000Z",
            "daysUntilSupportEnds": 248
        },
        {
            "version": "2.3.4",
            "image": "pingidentity/pingone-ldap-gateway:2.3.4",
            "supportEndsOn": "2024-11-30T00:00:00.000Z",
            "daysUntilSupportEnds": 217
        },
        {
            "version": "2.3.4",
            "image": "gcr.io/ping-identity/pingone/pingone-ldap-gateway:2.3.4",
            "supportEndsOn": "2024-11-30T00:00:00.000Z",
            "daysUntilSupportEnds": 217
        }
    ],
    "currentAlerts": [
        {
            "category": "No Instances Connected",
            "detail": "No gateway instances are connected. All operations that require access to this gateway will fail.",
            "severity": "ERROR"
        }
    ],
    "bindDN": "cn=svc-account",
    "connectionSecurity": "None",
    "vendor": "PingDirectory",
    "followReferrals": false,
    "userTypes": [
        {
            "id": "d426bb10-9804-4f61-a90a-7ef1fc4baf07",
            "name": "myType",
            "passwordAuthority": "LDAP",
            "searchBaseDn": "dc=example,dc=com",
            "orderedCorrelationAttributes": [
                "externalid",
                "uid",
                "username"
            ],
            "newUserLookup": {
                "ldapFilterPattern": "(|(uid=${identifier})(mail=${identifier}))",
                "population": {
                    "id": "f5d70107-ee11-481c-a73d-f3d812808d76"
                },
                "attributeMappings": [
                    {
                        "name": "username",
                        "value": "${ldapAttributes.uid}"
                    }
                ]
            },
            "allowPasswordChanges": false,
            "updateUserOnSuccessfulAuthentication": false
        }
    ],
    "validateTlsCertificates": true,
    "serversHostAndPort": [
        "host1:389",
        "host.domain.com:389",
        "10.10.10.10:333",
        "2001:0db8:85a3:0000:0000:8a2e:0370:7334:389"
    ]
}
```
